var logString = "";
var debug = false;
// debug = true;

function slice(number, digits) {
  return ('000' + number).slice(-digits);
}

function log(message) {
  var now = new Date();
  var timeString = slice(now.getHours(),2) + ":" + slice(now.getMinutes(),2) + ":" + slice(now.getSeconds(),2) + "." + slice(now.getMilliseconds(),3);
  logString = logString + timeString + " - " + message + "\n";
}

var numberOfScriptsLoaded = 0;
var numberOfScriptsNecessary = 0;
var audio;
var hour;
var minute;

function callback() {
  log("in callback");

  var riffHeader = [82,73,70,70,73,44,0,0,87,65,86,69,102,109,116,32,18,0,0,0,1,0,1,0,34,86,0,0,34,86,0,0,1,0,8,0,0,0,100,97,116,97,35,44,0,0];

  // distance in the riffHeader between the two length fields (value in byte)
  RIFF_HEADER_DISTANCE = 38

  // decode bzip2

  if ( minuteString == "00" ) {
    if (loadHour == 1) {
      hour = ArchUtils.bz2.decode(window.atob(hf[parseInt(hourString)])).getBytes();
    }

    completeLength = es_ist.length + hour.length;
    headerLength = completeLength + 2 * RIFF_HEADER_DISTANCE;

    minute = []
  } else {
    if (loadHour == 1) {
      hour = ArchUtils.bz2.decode(window.atob(h[parseInt(hourString)])).getBytes();
    }
    minute = ArchUtils.bz2.decode(window.atob(m[parseInt(minuteString)])).getBytes();

    completeLength = es_ist.length + hour.length + minute.length;
    headerLength = completeLength + 3 * RIFF_HEADER_DISTANCE;
  }

  // set length values in the new RIFF header
  for (index = 4 ; index < 8; index++) {
    riffHeader[index] = headerLength % 256;
    riffHeader[index + RIFF_HEADER_DISTANCE] = completeLength % 256;
    headerLength = headerLength >> 8;
    completeLength = completeLength >> 8;
  }

  log("before audio element");

  // create a new audio element with base64 encoding
  // for the combined wav files

/*
  => does not work in the browser "Konqueror"
  audio = new Audio();

  if (typeof audio === "undefined") {
    alert("Der Webbrowser unterstützt das Audio-Element von HTML5 nicht.");
    return;
  }
*/

  log("before audio src");

  audio.src = 'data:audio/wav;base64,' + FastBase64.Encode(riffHeader.concat(es_ist, hour, minute));
  // audio.load();

  log("before audio play");

  audio.play();
}

function loaded() {
  log("loaded " + numberOfScriptsLoaded + " " + numberOfScriptsNecessary);
  if (++numberOfScriptsLoaded == numberOfScriptsNecessary) {
    callback();
    log(numberOfScriptsLoaded);
  }
  log(numberOfScriptsLoaded);
};

function loadJavascriptFile(filename) {
  log(filename);
  var scriptElement = document.createElement('script')
  scriptElement.setAttribute("type","text/javascript")
  scriptElement.setAttribute("src", filename)
  document.getElementsByTagName("head")[0].appendChild(scriptElement)
}

function talk() {
  if (debug == true) {
    logString = ""
    setTimeout(function () {
      alert(logString);
    }, 3000);
  }

  var currentDate = new Date();
  minuteString = slice(currentDate.getMinutes(),2);
  hourString = slice(currentDate.getHours(),2);

  log(hourString + ":" + minuteString);

  if (typeof es_ist === "undefined") {
    es_ist = ArchUtils.bz2.decode(window.atob(e_es_ist)).getBytes();
  }

  log(es_ist.length);

  numberOfScriptsLoaded = 0;
  loadHour = 0;

  if ( minuteString == "00" ) {
    if (typeof hf[parseInt(hourString)] === "undefined") {
      loadHour = 1
      numberOfScriptsNecessary = 1
      loadJavascriptFile("sound/" + hourString + "_uhr.js");
      return;
    }
    audio.play();
  } else {
    if (typeof h[parseInt(hourString)] === "undefined") {
      loadHour = 1
      if (typeof m[parseInt(minuteString)] === "undefined") {
        log("minute and hour are undefined");
        numberOfScriptsNecessary = 2
        loadJavascriptFile("sound/" + hourString + "_uhr_.js");
        loadJavascriptFile("sound/" + minuteString + ".js");
        return;
      } else {
        log("minute is defined");
        numberOfScriptsNecessary = 1
        loadJavascriptFile("sound/" + hourString + "_uhr_.js");
        return;
      }
    } else {
      log("hour is defined");
      if (typeof m[parseInt(minuteString)] === "undefined") {
        numberOfScriptsNecessary = 1
        loadJavascriptFile("sound/" + minuteString + ".js");
        return;
      }
      log("before audio.play");
      audio.play();
      log("after audio.play");
    }
  }
}

window.onload = function() {

/*
  var currentDate = new Date();
  minuteString = slice(currentDate.getMinutes(),2);
  hourString = slice(currentDate.getHours(),2);

  var clockElement = document.getElementById("clockID");
  newText = "Es ist " + hourString + " Uhr";
  if ( minuteString != "00" ) {
    newText = newText + " " + minuteString;
  }
  clockElement.innerHTML = newText
*/

  // initialize sound arrays for hour and minute
  hf = [];
  h = [];
  m = [];

  audio = document.getElementById("audioSource");

  talk();
}
